/*Program Jetrek*/
//#pragma option -3 /*$G+*/
#pragma option -a+ /*$A+*/
#include <graphics.h>
#include <alloc.h>
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <stdlib.h>
#include "phasers.c"

#define TRUE 1
#define FALSE 0
#define OR ||
#define AND &&
#define NOT !
#define PI_180 3.1415927/180

int x[3],y[3],accx[3],accy[3],vx[3],vy[3],xt[3][65],yt[3][65],vtx[3][65],vty[3][65];
void far *p[3];
void far *tp[3];
short torps[3];
unsigned int mark[3],deg[3],energy[3],shpw[3];
short sheilds[3],cloak[3],cloaked[3],PHAS[3],photons[3],full[3],velocity[3],stop[3];
int i,c,w;
short winner,chan;
int gd,gm,A,B,ge,ch;
short bool,rthrust,lthrust,music;
unsigned char chr;

int get_chr(void)
{
 int x;
 if (kbhit()){
  if (NOT(x=(int)getch())){
   x=0x100+(int)getch();
  }
 }
 return(x);
}

void error(int d)
{
 puts("Im sorry, but an error occurred with the graphics module!");
 printf("error number:%d",d);
 exit(255);
}


void rec(int a,int b,int c,int d)
{
 rectangle(a,b,c,d);
 rectangle(a+320,b,c+320,d);
}

/*-------------------------------------------------------*/

void pix(int a,int b)
{
 putpixel(a,b,getcolor());
}

/*-------------------------------------------------------*/

void variables(void)
{
  bool = FALSE;
  winner = 0;
  A=((random(315))+6);
  B=((random(315))+320);
  x[1] = A;
  x[2] = B;
  for (i=1; i<3; i++)
   {
    A = random(269) + 6;
    y[i] =A;
    accx[i] = 0.001;
    accy[i] = 0.001;
    vx[i] = 0;
    vy[i] = 0;
    deg[i] = 0;
    sheilds[i] = FALSE;
    photons[i] = TRUE;
    PHAS[i] = TRUE;
    stop[i] = FALSE;
    full[i] = TRUE;
    velocity[i] = TRUE;
    cloak[i] = TRUE;
    cloaked[i] = FALSE;
    energy[i] = 0;
    torps[i] = 0;
    mark[i] = 0;
    shpw[i] = 10000;
    for (c=1;c<=64;c++)
     {
      vtx[i][c] = 0;
      vty[i][c] = 0;
      xt[i][c] = 0;
      yt[i][c] = 0;
     }
   }
}

/*-------------------------------------------------------*/

void up(short a)
{
if (energy[a] < 10)
	{
	 accx[a] += sin(deg[a]*PI_180)/5000;
	 accy[a] -= cos(deg[a]*PI_180)/5000;
	 energy[a] = energy[a] + 1;
	 setfillstyle(1,0);
	 bar(243+(a-1)*320,301,289+(a-1)*320,399);
	 setfillstyle(1,12);
	 bar(243+(a-1)*320,399-energy[a]*9,289+(a-1)*320,399);
	}
}

/*-------------------------------------------------------*/

void down(short a)
{
if (energy[a] > 0)
	{
	 accx[a] -= sin(deg[a]*PI_180)/5000;
	 accy[a] += cos(deg[a]*PI_180)/5000;
	 energy[a] = energy[a] - 1;
	 setfillstyle(1,0);
	 bar(243+(a-1)*320,301,289+(a-1)*320,399);
	 setfillstyle(1,12);
	 bar(243+(a-1)*320,399-energy[a]*9,289+(a-1)*320,399);
	}
}

/*-------------------------------------------------------*/

void left(short a)
{
 setcolor(0);
 for (i=1;i<=3;i++){
   arc((170+(a-1)*320),350,180-(deg[a]+2+90),180-(deg[a]-2+90),45+i);}
 if (deg[a] > 0) deg[a]-=4; else deg[a] = 356;
 setcolor(12);
 for (i=1;i<=3;i++){
   arc(170+(a-1)*320,350,180-(deg[a]+2+90),180-(deg[a]-2+90),45+i);}
}

/*-------------------------------------------------------*/

void right(short a)
{
setcolor(0);
for (i=1;i<=3;i++){
  arc(170+(a-1)*320,350,180-(deg[a]+2+90),180-(deg[a]-2+90),45+i);}
if (deg[a] < 356) deg[a]=deg[a]+4; else deg[a] = 0;
setcolor(12);
for (i=1;i<=3;i++){
  arc(170+(a-1)*320,350,180-(deg[a]+2+90),180-(deg[a]-2+90),45+i);
  }
}

/*-------------------------------------------------------*/

void fire(short a)
{
 if (music)
 {
  sound(400*a);
  delay(75);
  sound(600*a);
  delay(50);
  sound(400*a);
  delay(75);
  sound(350*a);
  delay(35);
  sound(325*a);
  delay(20);
  sound(300*a);
  delay(15);
  sound(250*a);
  delay(15);
  sound(200*a);
  delay(15);
  sound(150*a);
  delay(15);
  nosound();
 }
 vtx[a][(torps[a] % 50 + 1)] = vx[a] + sin(deg[a]*PI_180);
 vty[a][torps[a] % 50 + 1] = vy[a] - cos(deg[a]*PI_180);
 xt[a][torps[a] % 50 + 1] = x[a]+vtx[a][(torps[a] % 50) + 1]*10;
 yt[a][torps[a] % 50 + 1] = y[a]+vty[a][(torps[a] % 50) + 1]*20;
 torps[a]=torps[a]+1;
 putimage((int)(xt[a][(torps[a] % 50) + 1]),
	  (int)(yt[a][(torps[a] % 50) + 1]),tp[a],XOR_PUT);
	  }

/*-------------------------------------------------------*/

void draw_stuff(void)

{
 gd = DETECT;
 initgraph(&gd,&gm,"");
 ge=graphresult();
 if (ge != grOk) error(ge);
 setcolor(4);
 pix(0,0);
 pix(1,1);
 pix(2,2);
 pix(0,2);
 pix(2,0);
 setcolor(14);
 pix(4,0);
 pix(4,1);
 pix(4,2);
 pix(3,1);
 pix(5,1);
 setcolor(15);
 setfillstyle(1,15);
 circle(10,10,3);
 pix(10,10);
 pix(10,14);
 pix(10,15);
 line(8,14,8,19);
 bar(9,16,11,17);
 line(12,14,12,19);
 tp[1]=(void *)(farmalloc(imagesize(0,0,2,2)));
 getimage(0,0,2,2,tp);
 tp[2]=(void *)(farmalloc(imagesize(3,0,5,2)));
 getimage(3,0,5,2,tp[2]);
 p[1]=(void *)(farmalloc(imagesize(7,7,13,19)));
 getimage(7,7,13,19,p[1]);
 p[2]=(void *)(farmalloc(imagesize(7,7,13,19)));
 getimage(7,7,13,19,p[2]);
 cleardevice();
}

/*-------------------------------------------------------*/

void setup(void)

{
 setcolor(15);
 rectangle(0,0,639,279);
 rec(4,284,314,474);
 rec(4,284,114,404);
 rec(120,300,220,400);

 rec(100,440,120,460); /*a*/
 rec(125,450,145,470); /*z*/
 rec(150,440,170,460); /*s*/
 rec(125,415,145,435); /*w*/
 rectangle(90,410,110,430); /*q*/
 rectangle(180,441,230,459); /*space*/
 rectangle(505,410,525,430); /*1*/
 rectangle(505,440,555,460); /*0*/

 outtextxy(131,456,"s");
 outtextxy(106,446,"a");
 outtextxy(156,446,"d");
 outtextxy(131,421,"w");
 outtextxy(96,416,"q");
 outtextxy(186,446,"space");

 outtextxy(448,456,"dn");
 outtextxy(423,446,"lt");
 outtextxy(473,446,"rt");
 outtextxy(448,421,"up");
 outtextxy(512,416,"1");
 outtextxy(525,446,"0");

 outtextxy(139,289,"VELOCITY");
 outtextxy(459,289,"VELOCITY");
 outtextxy(242,289,"ENERGY");
 outtextxy(562,289,"ENERGY");
 setcolor(3);
 rec(242,300,290,400);
 outtextxy(9,289,"Cloak/Uncloak");
 outtextxy(329,289,"Cloak/Uncloak");
 outtextxy(9,302,"ShUp/ShDn");
 outtextxy(329,302,"ShUp/ShDn");
 outtextxy(9,315,"Phasers");
 outtextxy(329,315,"Phasers");
 outtextxy(9,328,"Torpedos");
 outtextxy(329,328,"Torpedos");
 outtextxy(9,341,"Full Stop");
 outtextxy(329,341,"Full Stop");
 outtextxy(9,354,"More Energy");
 outtextxy(329,354,"More Energy");
 outtextxy(9,367,"Less Energy");
 outtextxy(329,367,"Less Energy");
 outtextxy(9,380,"Left");
 outtextxy(329,380,"Left");
 outtextxy(9,393,"Right");
 outtextxy(329,393,"Right");
}

/*-------------------------------------------------------*/

void mark_move(short a)
{
setcolor(0);
outtextxy(320*(a-1)+4,(mark[a]) * 13 + 289,"|");
mark[a]++;
mark[a]=mark[a] % 9;
setcolor(2);
outtextxy(320*(a-1)+4,(mark[a]) * 13 + 289,"|");
}

/*-------------------------------------------------------*/

void readin(void)

{
 int ch;
 ch=get_chr();
 switch (ch){
    case 27:{
	     bool = TRUE;
	     break;
	    }
    case 328:{
	      up(2);
	      break;
	     }
    case 336:{
	      down(2);
	      break;
	     }
    case 331:{
	      left(2);
	      break;
	     }
    case 333:{
	      right(2);
	      break;
	     }
    case 119:{
	      up(1);
	      break;
	     }
    case 115:{
	      down(1);
	      break;
	     }
    case 97:{
	     left(1);
	     break;
	    }
    case 100:{
	      right(1);
	      break;
	     }
    case 32:{
	     switch (mark[1] % 9){
	      case 0:{
	       if(cloak[1])
		{
		 if (cloaked[1]==TRUE) cloaked[1] = FALSE; else cloaked[1] = TRUE;
		 putimage((int)x[1],(int)y[1],p[1],XOR_PUT);
		 break;
		}
	       }
	      case 1:{
		      if (sheilds[1]) sheilds[1]=FALSE; else sheilds[1] = TRUE;
		      break;
		     }
	      case 5:{
		      torps[1]=torps[1]+1;
		      shpw[1]=shpw[1]+50;
		      break;
		     }
	      case 3:{
		      if (torps[1] < 5000) fire(1);
		      break;
		     }
	      case 4:{
		      if (full[1])
		      {
		       stop[1] = TRUE;
		       accx[1] = 0;
		       accy[1] = 0;
		       energy[1] = 10;
		      }
		      break;
		     }
	      case 2:{
		      phaserc(2,1,deg[1],120,x[1],x[1]);
		      if (chkhitp(deg[1]+10,110,x[1],y[1],x[2],y[2]) OR chkhitp(deg[1]-10,110,x[1],y[1],x[2],y[2]))
		      {
		       if (sheilds[2]) shpw[2]=shpw[2]-500;
		       else winner=1;
		      }
		      break;
		     }
	      case 7:{
		      vx[1]=vx[1]+0.1;
		      lthrust=TRUE;
		      break;
		     }
	      case 8:{
		      vx[1]=vx[1]-0.1;
		      rthrust=TRUE;
		      break;
		     }

	      }
    case 48:{
     switch (mark[2] % 9){
       case 0:{if (cloak[2])
		 {
		  if (cloaked[2]) cloaked[2] = FALSE; else cloaked[2] = TRUE;
		  putimage((int)x[2],(int)y[2],p[2],XOR_PUT);
		 }
	       break;}
       case 1:{if (sheilds[2]) sheilds[2]=FALSE; else sheilds[2] = TRUE;
	       break;}
       case 2:{
	       phaserc(3,2,deg[2],120,x[2],y[2]);
	       if (chkhitp(deg[2]+15,110,x[2],y[2],x[1],y[1]) OR chkhitp(deg[2]-15,110,x[2],y[2],x[1],y[1]))
	       {
		if (sheilds[1]) shpw[1]=shpw[1]-500;
		else winner=2;
	       }
	       break;
	      }
       case 3:{if (torps[2] < 5000) fire(2);
	       break;}
       case 4:{if (full[2])
		{
		 stop[2] = TRUE;
		 accx[2] = 0;
		 accy[2] = 0;
		 energy[2] = 10;
		}
	       break;}
       case 5:{deathburst(2,x[2],y[2]);
	       break;}
       case 6:{deathburst(2,xt[2,1],yt[2,1]);
	       break;}
    }
   }
  }
    case 49:{mark_move(2);
	     break;}
    case 113:{mark_move(1);
	      break;}
 }
}



/*------------------------------------------------------------*/

void torp_bis(void)

{
  for (c=1;c<=10;c++){ if ((vtx[i][c] != 0) OR (vtx[i][c] != 0))
  {
   xt[i][c] = xt[i][c] + vtx[i][c];
   yt[i][c] = yt[i][c] + vty[i][c];
   if ((xt[i][c] < 0) OR (xt[i][c] > 627) OR
      (yt[i][c] < 0) OR (yt[i][c] > 265))
   {
    vtx[i][c] = 0;
    vty[i][c] = 0;
    xt[i][c] = 0;
    yt[i][c] = 0;
   };
  }
  for (w=0;w<=0;w++){
  if ((xt[i][c] < x[(i+w) % 2+1]+6) AND
     (xt[i][c]+3 > x[(i+w) % 2+1]) AND
     (yt[i][c] < y[(i+w) % 2+1]+12) AND
     (yt[i][c]+3 > y[(i+w) % 2+1]))
  if (!sheilds[(i+w) % 2 + 1])
  if (cloak[(i+w) % 2 + 1])
  {
    cloak[(i+w) % 2 + 1] = FALSE;
    xt[i][c] = xt[i][c] + vtx[i][c]*10;
    yt[i][c] = yt[i][c] + vty[i][c]*10;
  }
      else
  if (full[(i+w) % 2 + 1])
  {
    full[(i+w) % 2 + 1] = FALSE;
    xt[i][c] = xt[i][c] + vtx[i][c]*20;
    yt[i][c] = yt[i][c] + vty[i][c]*20;
  }
			   else winner = (i+w+1) % 2 + 1;
  else {
	vtx[i][c] = 0-vtx[i][c];
	vty[i][c] = 0-vty[i][c];
       }
    }
  }
}

/*-------------------------------------------------------*/

void loop_de_do(void)

{
 do{
  for (i=1;i<=2;i++){ if (!cloaked[i])
      putimage((int)x[i],(int)y[i], p[i],XOR_PUT);}
  for (i=1;i<=2;i++)
  for (c=1;c<=10;c++){ if ((vtx[i][c] != 0) AND (vty[i][c] !=0))
	putimage((int)xt[i][c],(int)yt[i][c],tp[i],XOR_PUT);}
  for (i=1;i<=2;i++)
   {

     if ((cloaked[1]) AND (sheilds[1]))
     {
      sheilds[1]=FALSE;
      cloaked[1]=FALSE;
      shpw[1]=50;
     }
     if ((sheilds[i]==TRUE) AND (shpw[i] <= 0)) sheilds[i] = FALSE;
     if (sheilds[i]==TRUE) shpw[i]-=i;
     setcolor(0);
     moveto(170+320*(i-1),350);
     linerel((vx[i]*50),(vy[i]*50));
     vx[i] = vx[i] + accx[i];
     vy[i] = vy[i] + accy[i];
     torp_bis();
     if (stop[i]==TRUE)
     {
       if (vx[i] < -0.002) vx[i] = vx[i] + 0.002;
       else if (vx[i] > 0.002) vx[i] = vx[i] - 0.002;
       else vx[i] = 0;
       if (vy[i] < -0.002) vy[i] = vy[i] + 0.002;
       else if (vy[i] > 0.002) vy[i] = vy[i] - 0.002;
       else vy[i] = 0;
       if ((vx[i] == 0) AND (vy[i] == 0))
       { stop[i] = FALSE;energy[i] = 0;}
     }
     setcolor(12);
     moveto(170+320*(i-1),350);
     linerel((vx[i]*50),(vy[i]*50));
   }
  readin();
  if ((x[1] < x[2]+6) AND
     (x[1]+6 > x[2]) AND
    (y[1] < y[2]+12) AND
     (y[1]+12 > y[2])) winner = 3;
  for (i=1;i<=2;i++)
   {
     if (!cloaked[i])
	putimage((int)x[i],(int)y[i],p[i],XOR_PUT);
     for (c=1;c<=10;++c) if ((vtx[i][c] != 0) OR (vty[i][c] != 0))
	putimage((int)xt[i][c],(int)yt[i][c],tp[i],XOR_PUT);
     x[i] = x[i] + vx[i];
     y[i] = y[i] + vy[i];
     if (x[i] > 627) x[i] = x[i] - 624;
     if (y[i] > 265) y[i] = y[i] - 262;
     if (x[i] < 3) x[i] = x[i] + 624;
     if (y[i] < 3) y[i] = y[i] + 262;
   }
 }while ((!bool) AND (winner == 0));
}

/*-------------------------------------------------------*/

void endin(void)

{
 if (music)
 {
  for (A=50; A<=150; A++);
   {
    sound(A*6);
    delay(15);
    nosound();
   }
  for (B=30; B<=10; B++);
   {
    sound(B*15);
    delay(25);
    nosound();
   }
 }
 if (winner == 3) gotoxy(14,14); else gotoxy(28,14);
 textcolor(14);
 if (winner!=3)
 printf("The Winner Was Player %i",winner);
 else puts("You Bozos Are So Stupid That You Crashed Into Each Other");
 ;
}
/*-------------------------------------------------------*/

void main(void)
{

 randomize();
 variables();
 draw_stuff();
 setup();
 loop_de_do();
 closegraph();
 clrscr();
 if (winner != 0) endin();
}